Package com.sas.metadata.remote

# Interface PropertyType

All Superinterfaces:
  `CMetadata`, `LocalizedType`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface PropertyType extends LocalizedType
Defines the data type of a property. Beginning with SAS 9.2, PropertyType is no longer a shared resource; instead, it is contained by the Property object that it helps to define. PropertyType is no longer considered to be an owning type. The SQL type of a Property object is now recorded in the SQLType= attribute of the Property object. Use PropertyType when the SQL type is set to other, 1111, or array, 2003 and more detail is needed to describe the type.

Attributes of PropertyType are:

- `SQLType`

Associations of PropertyType are:

- `ArrayTypes`
- `Customizers`
- `Editors`
- `ElementType`
- `StoredConfiguration`
- `TypedAttProperties`
- `TypedProperties`
- `Validators`

## Usage

To create an instance of this PropertyType, use the `factory` create methods.
Example: create a PropertyType with name "PropertyType_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     PropertyType myObject = (PropertyType) factory.createComplexMetadataObject(objectStore, "PropertyType_Object", MetadataObjects.PROPERTYTYPE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ARRAYTYPES_NAME`
  Constant used for the name of the ArrayTypes association.
  `static final String`
  `ASSOCIATION_CUSTOMIZERS_NAME`
  Constant used for the name of the Customizers association.
  `static final String`
  `ASSOCIATION_EDITORS_NAME`
  Constant used for the name of the Editors association.
  `static final String`
  `ASSOCIATION_ELEMENTTYPE_NAME`
  Constant used for the name of the ElementType association.
  `static final String`
  `ASSOCIATION_STOREDCONFIGURATION_NAME`
  Constant used for the name of the StoredConfiguration association.
  `static final String`
  `ASSOCIATION_TYPEDATTPROPERTIES_NAME`
  Constant used for the name of the TypedAttProperties association.
  `static final String`
  `ASSOCIATION_TYPEDPROPERTIES_NAME`
  Constant used for the name of the TypedProperties association.
  `static final String`
  `ASSOCIATION_VALIDATORS_NAME`
  Constant used for the name of the Validators association.
  `static final String`
  `ATTRIBUTE_SQLTYPE_NAME`
  Constant used for the name of the SQLType attribute.

  ### Fields inherited from interface com.sas.metadata.remote.LocalizedType

  `ASSOCIATION_RESOURCES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getArrayTypes()`
  Gets the AssociationList of `ArrayTypes`
  `AssociationList`
  `getArrayTypes(boolean fGoToServer)`
  Gets the Associationlist of `ArrayTypes`
  `AssociationList`
  `getCustomizers()`
  Gets the Association list of `Customizers`
  `AssociationList`
  `getCustomizers(boolean fGoToServer)`
  Gets the Associationlist of `Customizers`
  `AssociationList`
  `getEditors()`
  Gets the Association list of `Editors`
  `AssociationList`
  `getEditors(boolean fGoToServer)`
  Gets the Associationlist of `Editors`
  `PropertyType`
  `getElementType()`
  Gets the `PropertyType` for `ElementType`
  `AssociationList`
  `getElementTypes()`
  Gets the Association list of `ElementTypes`
  `AssociationList`
  `getElementTypes(boolean fGoToServer)`
  Gets the Associationlist of `ElementTypes`
  `int`
  `getSQLType()`
  Gets the `int` value of `SQLType`
  `int`
  `getSQLTypeState()`
  Gets the Metadata State of `SQLType`
  `Text`
  `getStoredConfiguration()`
  Gets the `Text` for `StoredConfiguration`
  `AssociationList`
  `getStoredConfigurations()`
  Gets the Association list of `StoredConfigurations`
  `AssociationList`
  `getStoredConfigurations(boolean fGoToServer)`
  Gets the Associationlist of `StoredConfigurations`
  `AssociationList`
  `getTypedAttProperties()`
  Gets the Association list of `TypedAttProperties`
  `AssociationList`
  `getTypedAttProperties(boolean fGoToServer)`
  Gets the Associationlist of `TypedAttProperties`
  `AssociationList`
  `getTypedProperties()`
  Gets the Association list of `TypedProperties`
  `AssociationList`
  `getTypedProperties(boolean fGoToServer)`
  Gets the Associationlist of `TypedProperties`
  `AssociationList`
  `getValidators()`
  Gets the Association list of `Validators`
  `AssociationList`
  `getValidators(boolean fGoToServer)`
  Gets the Associationlist of `Validators`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `ArrayTypes`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setArrayTypes(AssociationList list)`
  Sets the `ArrayTypes` list to be `list`.
  `void`
  `setArrayTypes(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setCustomizers(AssociationList list)`
  Sets the `Customizers` list to be `list`.
  `void`
  `setCustomizers(AssociationList inObjects, int state)`
  Sets the entire Customizers list to match the passed in AssociationList, sets the state of the Customizers
  `void`
  `setEditors(AssociationList list)`
  Sets the `Editors` list to be `list`.
  `void`
  `setEditors(AssociationList inObjects, int state)`
  Sets the entire Editors list to match the passed in AssociationList, sets the state of the Editors
  `void`
  `setElementType(PropertyType inObject)`
  Sets the `ElementTypes` list 0th element to be `inObject`.
  `void`
  `setElementTypes(AssociationList list)`
  Sets the `ElementTypes` list to be `list`.
  `void`
  `setElementTypes(AssociationList list, int state)`
  Sets the `ElementTypes` list to be `list`.
  `void`
  `setSQLType(int inSQLType)`
  Sets the `SQLType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSQLType(int inSQLType, int state)`
  Sets the `SQLType` Metadata State.
  `void`
  `setSQLType(String inSQLType)`
  Sets the `SQLType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSQLType(String inSQLType, int state)`
  Sets the `SQLType` value and Metadata State.
  `void`
  `setSQLTypeState(int state)`
  Sets the Metadata State of `SQLType`.
  `void`
  `setStoredConfiguration(Text inObject)`
  Sets the `StoredConfigurations` list 0th element to be `inObject`.
  `void`
  `setStoredConfigurations(AssociationList list)`
  Sets the `StoredConfigurations` list to be `list`.
  `void`
  `setStoredConfigurations(AssociationList list, int state)`
  Sets the `StoredConfigurations` list to be `list`.
  `void`
  `setTypedAttProperties(AssociationList list)`
  Sets the `TypedAttProperties` list to be `list`.
  `void`
  `setTypedAttProperties(AssociationList inObjects, int state)`
  Sets the entire TypedAttProperties list to match the passed in AssociationList, sets the state of the TypedAttProperties
  `void`
  `setTypedProperties(AssociationList list)`
  Sets the `TypedProperties` list to be `list`.
  `void`
  `setTypedProperties(AssociationList inObjects, int state)`
  Sets the entire TypedProperties list to match the passed in AssociationList, sets the state of the TypedProperties
  `void`
  `setValidators(AssociationList list)`
  Sets the `Validators` list to be `list`.
  `void`
  `setValidators(AssociationList inObjects, int state)`
  Sets the entire Validators list to match the passed in AssociationList, sets the state of the Validators

  ### Methods inherited from interface com.sas.metadata.remote.LocalizedType

  `getResources, getResources, setResources, setResources`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_SQLTYPE_NAME

    static final String ATTRIBUTE_SQLTYPE_NAME
    Constant used for the name of the SQLType attribute.

    SQLType: This is an integer value that identifies the SQL type of the data.

  - ARRAY = 2003
  - BIGINT = -5
  - BINARY = -2
  - BIT = -7
  - BLOB = 2004
  - CHAR = 1
  - CLOB = 2005
  - DATE = 91
  - DECIMAL = 3
  - DISTINCT = 2001
  - DOUBLE = 8
  - FLOAT = 6
  - INTEGER = 4
  - JAVA_OBJECT = 2000
  - LONGVARBINARY = -4
  - LONGVARCHAR = -1
  - NULL = 0
  - NUMERIC = 2
  - OTHER = 1111
  - REAL = 7
  - REF = 2006
  - SMALLINT = 5
  - STRUCT = 2002
  - TIME = 92
  - TIMESTAMP = 93
  - TINYINT = -6
  - VARBINARY = -3
  - VARCHAR = 12
  - QuotedString = 2200

See Also:
  - Constant Field Values

- ### ASSOCIATION_ARRAYTYPES_NAME

  static final String ASSOCIATION_ARRAYTYPES_NAME
  Constant used for the name of the ArrayTypes association.

  ArrayTypes: The arrays that use this PropertyType.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_CUSTOMIZERS_NAME

  static final String ASSOCIATION_CUSTOMIZERS_NAME
  Constant used for the name of the Customizers association.

  Customizers: The programs used to customize this object. A customizer is a standalone editor used to customize or edit a value. It does not reside inside a UI element as an editor does, but defines it's own window. If none exists on the entity, the customizer of the property type is returned.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_EDITORS_NAME

  static final String ASSOCIATION_EDITORS_NAME
  Constant used for the name of the Editors association.

  Editors: The programs that can edit this object. The editor is a component that can be placed inside a UI container, such as a property sheet, and that edits the property value.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_ELEMENTTYPE_NAME

  static final String ASSOCIATION_ELEMENTTYPE_NAME
  Constant used for the name of the ElementType association.

  ElementType: The PropertyType used in this array.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_STOREDCONFIGURATION_NAME

  static final String ASSOCIATION_STOREDCONFIGURATION_NAME
  Constant used for the name of the StoredConfiguration association.

  StoredConfiguration: The configuration information for this object.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_TYPEDATTPROPERTIES_NAME

  static final String ASSOCIATION_TYPEDATTPROPERTIES_NAME
  Constant used for the name of the TypedAttProperties association.

  TypedAttProperties: The attribute properties that are of this type.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_TYPEDPROPERTIES_NAME

  static final String ASSOCIATION_TYPEDPROPERTIES_NAME
  Constant used for the name of the TypedProperties association.

  TypedProperties: The properties that are of this type.

  See Also:
    - Constant Field Values

- ### ASSOCIATION_VALIDATORS_NAME

  static final String ASSOCIATION_VALIDATORS_NAME
  Constant used for the name of the Validators association.

  Validators: The programs used to validate the value of this PropertyType.

  See Also:
    - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `LocalizedType`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `ArrayTypes`
    Specified by:
      `initializePredObjects` in interface `LocalizedType`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSQLType

    int getSQLType() throws RemoteException
    Gets the `int` value of `SQLType`
    Returns:
      The `SQLType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSQLTypeState

    int getSQLTypeState() throws RemoteException
    Gets the Metadata State of `SQLType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getArrayTypes

    AssociationList getArrayTypes() throws RemoteException, MdException
    Gets the AssociationList of `ArrayTypes`
    Returns:
      Returns the AssociationList of `ArrayTypes` which can be of type:
      PropertyType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCustomizers

    AssociationList getCustomizers() throws RemoteException, MdException
    Gets the Association list of `Customizers`
    Returns:
      The AssociationList of `Customizers` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getEditors

    AssociationList getEditors() throws RemoteException, MdException
    Gets the Association list of `Editors`
    Returns:
      The AssociationList of `Editors` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getElementTypes

    AssociationList getElementTypes() throws RemoteException, MdException
    Gets the Association list of `ElementTypes`
    Returns:
      The AssociationList of `ElementTypes` which can be of type:
      PropertyType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getElementType

    PropertyType getElementType() throws RemoteException, MdException
    Gets the `PropertyType` for `ElementType`
    Returns:
      The `PropertyType` ( `null` if not set ) of `ElementType` which can be of type:
      PropertyType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getStoredConfigurations

    AssociationList getStoredConfigurations() throws RemoteException, MdException
    Gets the Association list of `StoredConfigurations`
    Returns:
      The AssociationList of `StoredConfigurations` which can be of type:
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getStoredConfiguration

    Text getStoredConfiguration() throws RemoteException, MdException
    Gets the `Text` for `StoredConfiguration`
    Returns:
      The `Text` ( `null` if not set ) of `StoredConfiguration` which can be of type:
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTypedAttProperties

    AssociationList getTypedAttProperties() throws RemoteException, MdException
    Gets the Association list of `TypedAttProperties`
    Returns:
      The AssociationList of `TypedAttProperties` which can be of type:
      AttributeProperty
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTypedProperties

    AssociationList getTypedProperties() throws RemoteException, MdException
    Gets the Association list of `TypedProperties`
    Returns:
      The AssociationList of `TypedProperties` which can be of type:
      Property
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getValidators

    AssociationList getValidators() throws RemoteException, MdException
    Gets the Association list of `Validators`
    Returns:
      The AssociationList of `Validators` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getArrayTypes

    AssociationList getArrayTypes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ArrayTypes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `ArrayTypes` which can be of type:
      PropertyType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCustomizers

    AssociationList getCustomizers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Customizers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Customizers` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getEditors

    AssociationList getEditors(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Editors`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Editors` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getElementTypes

    AssociationList getElementTypes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ElementTypes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `ElementTypes` which can be of type:
      PropertyType
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getStoredConfigurations

    AssociationList getStoredConfigurations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `StoredConfigurations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `StoredConfigurations` which can be of type:
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTypedAttProperties

    AssociationList getTypedAttProperties(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `TypedAttProperties`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `TypedAttProperties` which can be of type:
      AttributeProperty
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTypedProperties

    AssociationList getTypedProperties(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `TypedProperties`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `TypedProperties` which can be of type:
      Property
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getValidators

    AssociationList getValidators(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Validators`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Validators` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setSQLType

    void setSQLType(int inSQLType) throws RemoteException
    Sets the `SQLType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSQLType` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLType

    void setSQLType(int inSQLType, int state) throws RemoteException
    Sets the `SQLType` Metadata State.
    Parameters:
      `inSQLType` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLType

    void setSQLType(String inSQLType) throws RemoteException
    Sets the `SQLType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSQLType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLType

    void setSQLType(String inSQLType, int state) throws RemoteException
    Sets the `SQLType` value and Metadata State.
    Parameters:
      `inSQLType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSQLTypeState

    void setSQLTypeState(int state) throws RemoteException
    Sets the Metadata State of `SQLType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setArrayTypes

    void setArrayTypes(AssociationList list) throws RemoteException
    Sets the `ArrayTypes` list to be `list`. Objects of which can be of type:
    PropertyType
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setArrayTypes

    void setArrayTypes(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCustomizers

    void setCustomizers(AssociationList list) throws RemoteException
    Sets the `Customizers` list to be `list`. Objects of which can be of type:
    SoftwareComponent
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCustomizers

    void setCustomizers(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Customizers list to match the passed in AssociationList, sets the state of the Customizers
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEditors

    void setEditors(AssociationList list) throws RemoteException
    Sets the `Editors` list to be `list`. Objects of which can be of type:
    SoftwareComponent
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEditors

    void setEditors(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Editors list to match the passed in AssociationList, sets the state of the Editors
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setElementTypes

    void setElementTypes(AssociationList list) throws RemoteException
    Sets the `ElementTypes` list to be `list`. Objects of which can be of type:
    PropertyType
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setElementTypes

    void setElementTypes(AssociationList list, int state) throws RemoteException
    Sets the `ElementTypes` list to be `list`. Objects of which can be of type:
    PropertyType
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setElementType

    void setElementType(PropertyType inObject) throws RemoteException
    Sets the `ElementTypes` list 0th element to be `inObject`.
    Parameters:
      `inObject` - PropertyType
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStoredConfigurations

    void setStoredConfigurations(AssociationList list) throws RemoteException
    Sets the `StoredConfigurations` list to be `list`. Objects of which can be of type:
    Text
    TextStore
    SASCatalogEntry
    File
    ArchiveFile
    ArchiveEntry
    Document
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStoredConfigurations

    void setStoredConfigurations(AssociationList list, int state) throws RemoteException
    Sets the `StoredConfigurations` list to be `list`. Objects of which can be of type:
    Text
    TextStore
    SASCatalogEntry
    File
    ArchiveFile
    ArchiveEntry
    Document
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStoredConfiguration

    void setStoredConfiguration(Text inObject) throws RemoteException
    Sets the `StoredConfigurations` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Text
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTypedAttProperties

    void setTypedAttProperties(AssociationList list) throws RemoteException
    Sets the `TypedAttProperties` list to be `list`. Objects of which can be of type:
    AttributeProperty
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTypedAttProperties

    void setTypedAttProperties(AssociationList inObjects, int state) throws RemoteException
    Sets the entire TypedAttProperties list to match the passed in AssociationList, sets the state of the TypedAttProperties
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTypedProperties

    void setTypedProperties(AssociationList list) throws RemoteException
    Sets the `TypedProperties` list to be `list`. Objects of which can be of type:
    Property
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTypedProperties

    void setTypedProperties(AssociationList inObjects, int state) throws RemoteException
    Sets the entire TypedProperties list to match the passed in AssociationList, sets the state of the TypedProperties
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setValidators

    void setValidators(AssociationList list) throws RemoteException
    Sets the `Validators` list to be `list`. Objects of which can be of type:
    SoftwareComponent
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setValidators

    void setValidators(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Validators list to match the passed in AssociationList, sets the state of the Validators
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.